function [theta,iff] = sample_tnN(mu,iS,R,opts,N,mx)
% sample from truncated Normal(mu,S)
% iS = inv(S)
% R = chol(S)

if nargin == 5
    mx = Inf;
end

n = length(mu);
mu_s = quadprog(iS,- iS * mu,-eye(n),zeros(n,1),[],[],[],[],randn(n,1),opts);

g = (repmat(mu_s,1,N) + R' * randn(n,N))';
U = log(rand(N,1));
pdf = (repmat(mu_s,1,N)' - g) * iS * mu_s;

acc1 = ~any(g < 0,2);
acc2 = U <= pdf;
acc3 = ~any(g > mx,2);

yup = acc1 & acc2 & acc3;
smpls = g(yup,:);

iff = true;
theta = zeros(n,1);
if smpls
    theta = smpls(1,:)';
    iff = false;
elseif N == 2e3
    [theta,iff] = sample_tnN(mu,iS,R,opts,2e4,mx);
else
    sg = sum(g < 0,2);
    [a,~] = min(sg);
    if a ~= 0
        for ind = a:n
            tts = g(sg == ind,:);
            tt_size = size(tts,1);
            tts(tts < 0) = 0;
            tts(tts > mx) = mx;
            new_pdf = (repmat(mu_s,1,tt_size)' - tts) * iS * mu_s;
            for j = 1:tt_size
                if any(U <= new_pdf(j))
                    theta = tts(j,:)';
                    iff = false;
                    return
                end
            end
        end
    end
end

end